OGR: OGRGeometryCollection Class Reference

# OGRGeometryCollection Class Reference

`#include <ogr_geometry.h>`

Inheritance diagram for OGRGeometryCollection:

List of all members.

## Public Member Functions
| OGRGeometryCollection ()
virtual const char * | getGeometryName () const
virtual OGRwkbGeometryType | getGeometryType () const
virtual OGRGeometry * | clone () const
virtual void | empty ()
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
virtual void | flattenTo2D ()
virtual OGRBoolean | IsEmpty () const
virtual void | segmentize (double dfMaxLength)
virtual int | WkbSize () const
virtual OGRErr | importFromWkb (unsigned char *, int=-1)
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *) const
virtual OGRErr | importFromWkt (char **)
virtual OGRErr | exportToWkt (char **ppszDstText) const
virtual double | get_Area () const
virtual int | getDimension () const
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
int | getNumGeometries () const
OGRGeometry * | getGeometryRef (int)
virtual OGRBoolean | Equals (OGRGeometry *) const
virtual void | setCoordinateDimension (int nDimension)
virtual OGRErr | addGeometry (const OGRGeometry *)
virtual OGRErr | addGeometryDirectly (OGRGeometry *)
virtual OGRErr | removeGeometry (int iIndex, int bDelete=TRUE)
void | closeRings ()

## Detailed Description

A collection of 1 or more geometry objects.

All geometries must share a common spatial reference system, and Subclasses may impose additional restrictions on the contents.

## Constructor & Destructor Documentation

OGRGeometryCollection::OGRGeometryCollection | ( |  | ) |

Create an empty geometry collection.

## Member Function Documentation

OGRErr OGRGeometryCollection::addGeometry | ( | const OGRGeometry * | poNewGeom | ) | `[virtual]`

Add a geometry to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. The passed geometry is cloned to make an internal copy.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_AddGeometry().

Parameters:

  | poNewGeom | geometry to add to the container.

Returns:
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

References addGeometryDirectly(), and OGRGeometry::clone().

Referenced by OGRMultiPolygon::clone(), OGRMultiPoint::clone(), OGRMultiLineString::clone(), and clone().

OGRErr OGRGeometryCollection::addGeometryDirectly | ( | OGRGeometry * | poNewGeom | ) | `[virtual]`

Add a geometry directly to the container.

Some subclasses of OGRGeometryCollection restrict the types of geometry that can be added, and may return an error. Ownership of the passed geometry is taken by the container rather than cloning as addGeometry() does.

This method is the same as the C function OGR_G_AddGeometryDirectly().

There is no SFCOM analog to this method.

Parameters:

  | poNewGeom | geometry to add to the container.

Returns:
  OGRERR_NONE if successful, or OGRERR_UNSUPPORTED_GEOMETRY_TYPE if the geometry type is illegal for the type of geometry container.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

References OGRGeometry::getCoordinateDimension().

Referenced by addGeometry(), OGRGeometryFactory::createFromFgf(), and importFromWkt().

OGRGeometry * OGRGeometryCollection::clone | ( |  | ) | const`[virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

References addGeometry(), OGRGeometry::assignSpatialReference(), and OGRGeometry::getSpatialReference().

void OGRGeometryCollection::closeRings | ( |  | ) | `[virtual]`

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

References getGeometryType(), and wkbPolygon.

void OGRGeometryCollection::empty | ( |  | ) | `[virtual]`

Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

Referenced by importFromWkb(), OGRMultiPolygon::importFromWkt(), OGRMultiPoint::importFromWkt(), OGRMultiLineString::importFromWkt(), and importFromWkt().

OGRBoolean OGRGeometryCollection::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Returns two if two geometries are equivalent.

This method is the same as the C function OGR_G_Equal().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

References OGRGeometry::Equals(), getGeometryRef(), getGeometryType(), OGRGeometry::getGeometryType(), and getNumGeometries().

OGRErr OGRGeometryCollection::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData |
| ) |  |  | const`[virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb().

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

References OGRGeometry::exportToWkb(), getGeometryType(), and OGRGeometry::WkbSize().

OGRErr OGRGeometryCollection::exportToWkt | ( | char ** | ppszDstText | ) | const`[virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer.

Returns:
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

References OGRGeometry::exportToWkt(), getGeometryName(), and getNumGeometries().

void OGRGeometryCollection::flattenTo2D | ( |  | ) | `[virtual]`

Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRGeometryCollection::get_Area | ( |  | ) | const`[virtual]`

Compute area of geometry collection.

The area is computed as the sum of the areas of all members in this collection.

Note:
  No warning will be issued if a member of the collection does not support the get_Area method.

Returns:
  computed area.

Reimplemented in OGRMultiPolygon.

References getGeometryName(), OGRGeometry::getGeometryType(), wkbGeometryCollection, wkbLinearRing, wkbLineString, wkbMultiPolygon, and wkbPolygon.

int OGRGeometryCollection::getDimension | ( |  | ) | const`[virtual]`

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns:
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

void OGRGeometryCollection::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

References OGRGeometry::getEnvelope().

const char * OGRGeometryCollection::getGeometryName | ( |  | ) | const`[virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by exportToWkt(), get_Area(), and importFromWkt().

OGRGeometry * OGRGeometryCollection::getGeometryRef | ( | int | i | ) |

Fetch geometry from container.

This method returns a pointer to an geometry within the container. The returned geometry remains owned by the container, and should not be modified. The pointer is only valid untill the next change to the geometry container. Use IGeometry::clone() to make a copy.

This method relates to the SFCOM IGeometryCollection::get_Geometry() method.

Parameters:

  | i | the index of the geometry to fetch, between 0 and getNumGeometries() - 1.

Returns:
  pointer to requested geometry.

Referenced by OGRMultiPolygon::clone(), OGRMultiPoint::clone(), OGRMultiLineString::clone(), OGRGeometry::dumpReadable(), Equals(), OGRMultiPolygon::exportToWkt(), OGRMultiPoint::exportToWkt(), OGRMultiLineString::exportToWkt(), OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), OGRGeometryFactory::forceToMultiPolygon(), OGRGeometryFactory::forceToPolygon(), OGRMultiPolygon::get_Area(), and OGRBuildPolygonFromEdges().

OGRwkbGeometryType OGRGeometryCollection::getGeometryType | ( |  | ) | const`[virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implements OGRGeometry.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

References OGRGeometry::getCoordinateDimension(), wkbGeometryCollection, and wkbGeometryCollection25D.

Referenced by closeRings(), Equals(), and exportToWkb().

int OGRGeometryCollection::getNumGeometries | ( |  | ) | const

Fetch number of geometries in container.

This method relates to the SFCOM IGeometryCollect::get_NumGeometries() method.

Returns:
  count of children geometries. May be zero.

Referenced by OGRMultiPolygon::clone(), OGRMultiPoint::clone(), OGRMultiLineString::clone(), OGRGeometry::dumpReadable(), Equals(), OGRMultiPolygon::exportToWkt(), OGRMultiPoint::exportToWkt(), OGRMultiLineString::exportToWkt(), exportToWkt(), OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), OGRGeometryFactory::forceToMultiPolygon(), OGRGeometryFactory::forceToPolygon(), OGRMultiPolygon::get_Area(), and OGRBuildPolygonFromEdges().

OGRErr OGRGeometryCollection::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1` |
| ) |  |  | `[virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

References OGRGeometryFactory::createFromWkb(), empty(), OGRGeometry::getCoordinateDimension(), wkbGeometryCollection, wkbMultiLineString, wkbMultiPoint, wkbMultiPolygon, and OGRGeometry::WkbSize().

OGRErr OGRGeometryCollection::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

References addGeometryDirectly(), OGRGeometryFactory::createFromWkt(), empty(), and getGeometryName().

OGRBoolean OGRGeometryCollection::IsEmpty | ( |  | ) | const`[virtual]`

Returns TRUE (non-zero) if the object has no points. Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

Referenced by OGRMultiPoint::exportToWkt().

OGRErr OGRGeometryCollection::removeGeometry | ( | int | iGeom,
|  | int | bDelete = `TRUE` |
| ) |  |  | `[virtual]`

Remove a geometry from the container.

Removing a geometry will cause the geometry count to drop by one, and all "higher" geometries will shuffle down one in index.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_RemoveGeometry().

Parameters:

  | iGeom | the index of the geometry to delete. A value of -1 is a special flag meaning that all geometries should be removed.
  | bDelete | if TRUE the geometry will be deallocated, otherwise it will not. The default is TRUE as the container is considered to own the geometries in it.

Returns:
  OGRERR_NONE if successful, or OGRERR_FAILURE if the index is out of range.

Referenced by OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), and OGRGeometryFactory::forceToMultiPolygon().

void OGRGeometryCollection::segmentize | ( | double | dfMaxLength | ) | `[virtual]`

Modify the geometry such it has no segment longer then the given distance. Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters:

  | hGeom | handle on the geometry to segmentize
  | dfMaxLength | the maximum distance between 2 points after segmentization

Reimplemented from OGRGeometry.

void OGRGeometryCollection::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

References OGRGeometry::setCoordinateDimension().

OGRErr OGRGeometryCollection::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

References OGRGeometry::assignSpatialReference(), OGRCoordinateTransformation::GetTargetCS(), and OGRGeometry::transform().

int OGRGeometryCollection::WkbSize | ( |  | ) | const`[virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implements OGRGeometry.

References OGRGeometry::WkbSize().

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrgeometrycollection.cpp

Generated for GDAL by 1.5.9.